local MAJOR, MINOR = "LibFail-2.0", tonumber("114") or 999

assert(LibStub, MAJOR.." requires LibStub")

local lib = LibStub:NewLibrary(MAJOR, MINOR)
if not lib then return end
--[===[@debug@
-- ### debug
lf = lib
--@end-debug@]===]
lib.callbacks = lib.callbacks or LibStub("CallbackHandler-1.0"):New(lib)
local callbacks = lib.callbacks

lib.frame = lib.frame or CreateFrame("Frame")
local frame = lib.frame

local LGT = LibStub:GetLibrary("LibGroupTalents-1.0")
local LEJB = LibStub:GetLibrary("LibLocalizedEJBosses-1.0")

frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("ZONE_CHANGED")

-------------------------------------------------------------------------
-- LOCALES
-------------------------------------------------------------------------
local L = LibStub("AceLocale-3.0"):NewLocale("LibFail-2.0", "enUS", true)

-- ### remember to remove debug events
--L["Caleb's fail"] = true
--L["Holy light lulz"] = true

-- Strings related to fails
L["rolls left"] = true
L["rolls right"] = true
L["Barrel Roll"] = true

-- Constraint Names
L["Damage Constraint"] = true
L["Tick Constraint"] = true
L["Time Constraint - Low"] = true
L["Time Constraint - High"] = true

-- Fail Types
L["not moving"] = true
L["moving"] = true
L["not spreading"] = true
L["spreading"] = true
L["dispelling"] = true
L["not dispelling"] = true
L["not being at the wrong place"] = true
L["not casting"] = true
L["not attacking"] = true
L["casting"] = true
L["switching"] = true

-- You can request strings to be added to the common strings in a ticket at the addons page
-- Common strings
L["Fail"] = true
L["Fails"] = true
L["%s fails at %s"] = true
L["%s fails at %s (%s)"] = true
L["'s Fails"] = true
L["'s Failers"] = true
L["'s Fail Events"] = true
L["Tanks Dont Fail"] = true
L["Overkill Only"] = true

local L = LibStub("AceLocale-3.0"):GetLocale("LibFail-2.0")

-- Fail Event Names
-- Naming scheme for fail events:
-- Fail_Zone Name_Boss Name_Ability Name
-- only add non general events to the list
-- ["Fail_Zone Name_Boss Name_Ability Name"] = { { spellId list }, FAIL_TYPE, event name or spellId, description or spellId, true if tanks do not fail, true for overkill only },
-- Some of these spellids need verification, but are probably right.
local failEvents = {
	-- ### remember to remove debug events
	--["Fail_Glob -'bal_Maat_HL"] = { { 635 }, "FAIL_TYPE_NOTCASTING", 635, L["Holy light lulz"], true },
	--["Fail_Glob -'bal_Ca 'leb_Dismiss Pet"] = { { 2641 }, "FAIL_TYPE_NOTCASTING", L["Caleb's fail"], L["Caleb's fail"] },
	["Fail_The Bastion of Twilight_Theralion and Valiona_Deep Breath"] = { { 86059 }, "FAIL_TYPE_MOVING", 86059, 86059 },
	["Fail_The Bastion of Twilight_Theralion and Valiona_Twilight Meteorite"] = { { 86014, 92863, 92864, 92865 }, "FAIL_TYPE_WRONGPLACE", 92864, 92864 },
	["Fail_The Bastion of Twilight_Theralion and Valiona_Devouring Flames"] = { { 86844, 92872, 92873, 92874 }, "FAIL_TYPE_MOVING", 86844, 86844 },
	["Fail_The Bastion of Twilight_Ascendant Council_Flame Torrent"] = { { 88558, 92516, 92517, 92518 }, "FAIL_TYPE_WRONGPLACE", 82777, 82777, true },
	["Fail_The Bastion of Twilight_Ascendant Council_Frozen"] = { { 82772, 92503, 92504, 92505 }, "FAIL_TYPE_MOVING", 92504, 92504 },
	["Fail_The Bastion of Twilight_Ascendant Council_Flame Strike"] = { { 92215 }, "FAIL_TYPE_MOVING", 92215, 92215 },
	["Fail_The Bastion of Twilight_Ascendant Council_Lava Plume"] = { { 84912, 92491, 92492, 92493 }, "FAIL_TYPE_MOVING", 92491, 92491 },
	["Fail_The Bastion of Twilight_Cho'gall_Blood"] = { {}, nil, 93174, 93174 },
	["Fail_Blackwing Descent_Maloriak_Consuming Flames"] = { { 77786, 92972, 92973, 92971 }, "FAIL_TYPE_MOVING", 77786, 77786, true },
	["Fail_Blackwing Descent_Maloriak_Scorching Blast"] = { { 77679, 92968, 92969, 92970 }, "FAIL_TYPE_WRONGPLACE", 77679, 77679, true },
	["Fail_Blackwing Descent_Maloriak_Engulfing Darkness"] = { { 92787, 92981, 92982, 92983 }, "FAIL_TYPE_MOVING", 92983, 92983, true },
	["Fail_Blackwing Descent_Maloriak_Dark Sludge"] = { { 92930, 92986, 92987, 92988 }, "FAIL_TYPE_MOVING", 92988, 92988 },
	["Fail_Blackwing Descent_Maloriak_Magma Jets"] = { { 93014, 93015, 93016, 93038, 93039, 93040 }, "FAIL_TYPE_MOVING", 93016, 93016 },
	["Fail_Blackwing Descent_Maloriak_Absolute Zero"] = { { 78208, 93041, 93042, 93043 }, "FAIL_TYPE_MOVING", 93043, 93043 },
	["Fail_Blackwing Descent_Atramedes_Sonic Breath"] = { { 78100, 92407, 92408, 92409 }, "FAIL_TYPE_MOVING", 92408, 92408 },
	["Fail_Blackwing Descent_Atramedes_Sonar Pulse"] = { { 77675, 92417, 92418, 92419 }, "FAIL_TYPE_MOVING", 92418, 92418 },
	["Fail_Blackwing Descent_Nefarian's End_Shadow Of Cowardice"] = { { 79353 }, "FAIL_TYPE_MOVING", 79353, 79353 },
	["Fail_Blackwing Descent_Nefarian's End_Tail Lash"] = { { 77827, 94128, 94129, 94130 }, "FAIL_TYPE_WRONGPLACE", 94129, 94129 },
	["Fail_Blackwing Descent_Nefarian's End_Magma"] = { { 81118, 94073, 94074, 94075 }, "FAIL_TYPE_MOVING", 94073, 94073 },
	["Fail_Blackwing Descent_Nefarian's End_Shadowblaze"] = { { 81007, 94085, 94086, 94087 }, "FAIL_TYPE_MOVING", 94085, 94085, true },
	["Fail_Blackwing Descent_Nefarian's End_Stolen Power"] = { {}, "FAIL_TYPE_NOTATTACKING", 80627, 80627},
	["Fail_Throne of the Four Winds_Al'Akir_Squall Line"] = { { 87856, 93283, 93284, 93285 }, "FAIL_TYPE_MOVING", 93283, (GetSpellInfo(1680)) },
	["Fail_Throne of the Four Winds_The Conclave of Wind_Wind Blast"] = { { 85483, 93138, 93139, 93140 }, "FAIL_TYPE_MOVING", 93139, 93139 },
	["Fail_Throne of the Four Winds_The Conclave of Wind_Toxic Spores"] = { { 86282, 93120, 93121, 93122 }, "FAIL_TYPE_MOVING", 93121, 93121 },
	["Fail_Throne of the Four Winds_The Conclave of Wind_Permafrost"] = { { 86081, 93126, 93127, 93128 }, "FAIL_TYPE_WRONGPLACE", 93128, 93128, true },
	["Fail_Blackwing Descent_Omnotron Defense System_Barrier"] = { {}, nil, 91517, 91517 },
	["Fail_Blackwing Descent_Omnotron Defense System_Chemical Cloud"] = { { 91471, 91472, 91473 }, "FAIL_TYPE_MOVING", 91472, 91472 },
	["Fail_Blackwing Descent_Omnotron Defense System_Arcane Blowback"] = { { 91879, 91880 }, "FAIL_TYPE_MOVING", 91880, 91880 },
	["Fail_Blackwing Descent_Omnotron Defense System_Poison Bomb"] = { {91499, 91500 }, "FAIL_TYPE_MOVING", 91499, 91499 },
	["Fail_Blackwing Descent_Omnotron Defense System_Flamethrower"] = { { 79504, 91535, 91536, 91537 }, "FAIL_TYPE_MOVING", 91535, 91535 },
	["Fail_Blackwing Descent_Magmaw_Parasitic Infection"] = { { 78941, 91913, 94678, 94679 }, "FAIL_TYPE_MOVING", 91913, 91913 },
	["Fail_Blackwing Descent_Magmaw_Pillar of Flame"] = { { 77971, 91918, 91929, 91930 }, "FAIL_TYPE_MOVING", 91918, 91918 },
	["Fail_Blackwing Descent_Magmaw_Ignition"] = { { 92131, 92196, 92197, 92198 }, "FAIL_TYPE_MOVING", 92198, 92198 },
	["Fail_Blackwing Descent_Magmaw_Massive Crash"] = { { 88287, 91914, 91921, 91922 }, "FAIL_TYPE_MOVING", 91922, 91922 },
	["Fail_The Bastion of Twilight_Cho'gall_Blaze"] = { { 81538, 93212, 93213 }, "FAIL_TYPE_MOVING", 93213, 93213 },
	["Fail_The Bastion of Twilight_Cho'gall_Corrupting Crash"] = { { 81689, 93184, 93185, 93186 }, "FAIL_TYPE_MOVING", 93185, 93185 },
	["Fail_Blackwing Descent_Atramedes_Sonar Bomb"] = { { 92553, 92554, 92555, 92556 }, "FAIL_TYPE_MOVING", 92555, 92555 },
	["Fail_The Bastion of Twilight_Sinestra_Twilight Slicer"] = { { 92852, 92954 }, "FAIL_TYPE_MOVING", 92954, 92954, nil, true },
	["Fail_The Bastion of Twilight_Sinestra_Twilight Extinction"] = { { 86226 }, "FAIL_TYPE_MOVING", 86226, 86226, nil, true },
	["Fail_The Bastion of Twilight_Sinestra_Twilight Pulse"] = { { 78862, 92958, 92959 }, "FAIL_TYPE_MOVING", 92959, 92959 },
	["Fail_Firelands_Lord Rhyolith_Immolation"] = { { 98598, 100414 }, "FAIL_TYPE_MOVING", 98598, 98598, true },
	["Fail_Firelands_Lord Rhyolith_Magma"] = { { 98472 }, "FAIL_TYPE_MOVING", 98472, 98472 },
	["Fail_Firelands_Lord Rhyolith_Magma Flow"] = { { 97230, 97234, 99631, 101017, 101018,  }, "FAIL_TYPE_MOVING", 99631, 99631 },
	["Fail_Firelands_Alysrazor_Fiery Tornado"] = { { 99816, 100733, 100734, 100735 }, "FAIL_TYPE_MOVING", 99816, 99816 },
	["Fail_Firelands_Alysrazor_Firestorm"] = { { 101664, 101665, 101666, 100745 }, "FAIL_TYPE_MOVING", 101666, 101666 },
	["Fail_Firelands_Alysrazor_Lava Spew"] = { { 99336, 100725, 100726, 100727 }, "FAIL_TYPE_MOVING", 99336, 99336, true },
	["Fail_Firelands_Alysrazor_Brushfire"] = { { 98885, 100715, 100716, 100717 }, "FAIL_TYPE_MOVING", 100717, 100717, true },
	["Fail_Firelands_Alysrazor_Gushing Wound"] = { { 99308, 100720, 100723, 100721, 100718, 100024 }, "FAIL_TYPE_MOVING", 99308, 99308, true },
	["Fail_Firelands_Alysrazor_Harsh Winds"] = { { 100640 }, "FAIL_TYPE_MOVING", 100640, 100640, false },
	["Fail_Firelands_Shannox_Crystal Prison Trap"] = { { 99837 }, "FAIL_TYPE_MOVING", 99837, 99837 },
	["Fail_Firelands_Shannox_Immolation Trap"] = { { 99838, 101208, 101209, 101210 }, "FAIL_TYPE_MOVING", 99838, 99838, true },
	["Fail_Firelands_Ragnaros_Engulfing Flames"] = { { 99224, 100187, 100188, 100189 }, "FAIL_TYPE_MOVING", 99236, 99236, nil, true },
	["Fail_Firelands_Ragnaros_Lava Wave"] = { { 98928, 100292, 100293, 100294 }, "FAIL_TYPE_MOVING", 98928, 98928, nil, true },
	["Fail_Firelands_Ragnaros_Dreadflame"] = { { 100998 }, "FAIL_TYPE_MOVING", 100998, 100998 },
	["Fail_Firelands_Majordomo Staghelm_Searing Seed"] = { { 98620, 100215, 100216, 100217 }, "FAIL_TYPE_MOVING", 100215, 100215 },
	["Fail_Firelands_Majordomo Staghelm_Flame Scythe"] = { { 100212, 100213 }, "FAIL_TYPE_WRONGPLACE", 100212, 100212 },
	["Fail_Firelands_Majordomo Staghelm_Leaping Flames"] = { { 100206, 100207 }, "FAIL_TYPE_MOVING", 100206, 100206 },
	["Fail_Firelands_Majordomo Staghelm_Burning Orb"] = { { 98584, 100210, 100209, 100211 }, "FAIL_TYPE_MOVING", 98584, 98584 },
	["Fail_Firelands_Baleroc, the Gatekeeper_Torment"] = { { 100230, 100232 }, "FAIL_TYPE_MOVING", 100230, 100230 },
	["Fail_Firelands_Baleroc, the Gatekeeper_Tormented"] = { { 99402, 99404 }, "FAIL_TYPE_MOVING", 99402, 99402 },
	["Fail_Firelands_Ragnaros_Sulfuras Smash"] = { { 98708, 100256, 100257, 100258 }, "FAIL_TYPE_MOVING", 100258, 100258, nil, true },
	["Fail_Firelands_Ragnaros_Hand of Ragnaros"] = { { 98237, 100384, 100387 }, "FAIL_TYPE_NOTCASTING", 98237, 98237 },
	["Fail_Firelands_Ragnaros_Wrath of Ragnaros"] = { { 100115, 100114, 100113, 98263 }, "FAIL_TYPE_WRONGPLACE", 100115, 100115 },

	["Fail_Halls of Origination_Isiset, Construct of Magic_Supernova"] = { { 74137 }, "FAIL_TYPE_MOVING", 90758, 90758 }, -- AURA_APPLIED means blinded
	["Fail_Halls of Origination_Earthrager Ptah_Consume"] = { { 75369 }, "FAIL_TYPE_MOVING", 75369, 75369 }, -- lifted by cyclone

	["Fail_Zul'Gurub_Jin'do the Godbreaker_Twisted Spirit"] = { { }, nil, 97297, 97297, true, true },
	["Fail_Zul'Gurub_Zanzil_Toxic Torment"] = { { 96328 }, "FAIL_TYPE_NOTDISPELLING", 96328, 96328 },
	["Fail_Zul'Gurub_Zanzil_Frostburn Formula"] = { { 96325 }, "FAIL_TYPE_NOTDISPELLING", 96325, 96325 },

	["Fail_Dragon Soul_Morchok_Stomp"] = { { 108571, 109033, 109034, 103414 }, "FAIL_TYPE_WRONGPLACE", 108571, 108571 },
	["Fail_Dragon Soul_Ultraxion_Fading Light"] = { { 105926, 110073, 110074, 110075 }, "FAIL_TYPE_CASTING", 105926, 105926 },
	["Fail_Dragon Soul_Warmaster Blackhorn_Twilight Flames"] = { { 108051 }, "FAIL_TYPE_MOVING", 108051, 108051 },
	["Fail_Dragon Soul_Spine of Deathwing_Barrel Roll"] = { { }, nil, L["Barrel Roll"], L["Barrel Roll"] },
	["Fail_Dragon Soul_Yor'sahj the Unsleeping_Deep Corruption"] = { { 108220, 108348, 108349, 109389, 109390, 108347, 105173, 103628 }, "FAIL_TYPE_NOTCASTING", 109389, 109389 },
	["Fail_Dragon Soul_Spine of Deathwing_Fiery Grip"] = { { 109457, 109458, 109459, 105490 }, "FAIL_TYPE_CASTING", 109457, 109457 },
}

-- ["Fail_Zone Name_Boss Name_Ability Name"] = { { spellId list }, FAIL_TYPE, event name or spellId, description or spellId, true if tanks do not fail, true if its only overkill (false to default off, nil for no option) },
-- Don't forget to add damageConstraint at the globals section if necesary
local generalDamageFail = {
	["Fail_Baradin Hold_Occu'thar_Searing Shadows"] = { { 96913, 101007 }, "FAIL_TYPE_MOVING", 96913, 96913, true, false },
	["Fail_Baradin Hold_Occu'thar_Focused Fire"] = { { 96883, 97212, 101004 }, "FAIL_TYPE_MOVING", 101004, 101004, nil, true },
	["Fail_Baradin Hold_Argaloth_Fel Firestorm"] = { { 89000, 95177 }, "FAIL_TYPE_MOVING", 88972, 88972, nil, true },
	["Fail_The Bastion of Twilight_Halfus Wyrmbreaker_Fireball Barrage"] = { { 83734, 86154, 86153 }, "FAIL_TYPE_MOVING", 83734, 83734, nil, false },
	["Fail_The Bastion of Twilight_Ascendant Council_Glaciate"] = { { 82746, 92506, 92507, 92508 }, "FAIL_TYPE_MOVING", 92506, 92506, nil, false },
	["Fail_The Bastion of Twilight_Ascendant Council_Thundershock"] = { { 83067, 92469, 92470, 92471 }, "FAIL_TYPE_MOVING", 92469, 92469, nil, true },
	["Fail_The Bastion of Twilight_Ascendant Council_Quake"] = { {  83565, 92544, 92545, 92546 }, "FAIL_TYPE_MOVING", 92544, 92544, nil, true },
	["Fail_The Bastion of Twilight_Ascendant Council_Eruption"] = { { 83692, 92534, 92535, 92536 }, "FAIL_TYPE_MOVING", 92535, 92535, nil, false },
	["Fail_Firelands_Beth'tilac_Meteor Burn"] = { { 99076 }, "FAIL_TYPE_MOVING", 99076, 99076 },
	["Fail_Firelands_Alysrazor_Incendiary Cloud"] = { { 99427, 100729, 100730, 100731 }, "FAIL_TYPE_MOVING", 99427, 99427 },
	["Fail_Firelands_Ragnaros_Molten Seed"] = { { 98498, 100581, 100579, 100580 }, "FAIL_TYPE_MOVING", 98498, 98498, nil, true },
	["Fail_The Bastion of Twilight_Ascendant Council_Twilight Rupture"] = { { 93377, 93379, 93391 }, "FAIL_TYPE_MOVING", 93377, 93377 }, -- trash
	["Fail_Firelands_Ragnaros_Molten Eruption"] = { { 99580 }, "FAIL_TYPE_MOVING", 99580, 99580 }, -- trash
	["Fail_Firelands_Ragnaros_Lava"] = { { 99510 }, "FAIL_TYPE_MOVING", 99510, 99510, nil, true }, -- trash

	--["Fail_Firelands_Lord Rhyolith_Explosion"] = { { 98492 }, "FAIL_TYPE_MOVING", 98492, 98492 },

	["Fail_Throne of the Tides_Lady Naz'jar_Summon Geyser"] = { { 75722, 91469 }, "FAIL_TYPE_MOVING", 75722, 75722, nil, false },
	["Fail_Throne of the Tides_Lady Naz'jar_Waterspout"] = { { 90479 }, "FAIL_TYPE_MOVING", 90479, 90479, nil, false },
	["Fail_Throne of the Tides_Commander Ulthok, the Festering Prince_Dark Fissure"] = { { 76047, 76085, 91375, 96311 }, "FAIL_TYPE_MOVING", 96311, 96311, nil, true },
	["Fail_Throne of the Tides_Mindbender Ghur'sha_Ground Pound"] = { { 76590, 76593, 91468 }, "FAIL_TYPE_MOVING", 76590, 76590, nil, true }, -- trash
	["Fail_Throne of the Tides_Mindbender Ghur'sha_Earth Shards"] = { { 84931, 84945, 91491 }, "FAIL_TYPE_MOVING", 91491, 91491, nil, true },
	["Fail_Throne of the Tides_Mindbender Ghur'sha_Magma Splash"] = { { 76170 }, "FAIL_TYPE_WRONGPLACE", 76170, 76170, true, true },
	["Fail_Throne of the Tides_Ozumat_Aura of Dread"] = { { 83970, 83971 }, "FAIL_TYPE_WRONGPLACE", 83970, 83970, true, true },

	["Fail_Blackrock Caverns_Rom'ogg Bonecrusher_The Skullcracker"] = { { 75428, 93454, 95326 }, "FAIL_TYPE_MOVING", 93453, 93453, nil, true },
	--todo: player becoming Twilight Drakonid (100 stack of Evolution)
	--["Fail_Blackrock Caverns_Corla, Herald of Twilight_Twilight Evolution"] = { { 75732 }, "FAIL_TYPE_MOVING", 75732, 75732 },
	["Fail_Blackrock Caverns_Beauty_Lava Drool"] = { { 93666, 76628 }, "FAIL_TYPE_MOVING", 93666, 93666, nil, true },
	["Fail_Blackrock Caverns_Ascendant Lord Obsidius_Shadow Prison"] = { { 76687, 93674 }, "FAIL_TYPE_NOTMOVING", 93674, 93674, nil, true }, -- trash

	["Fail_Grim Batol_General Umbriss_Blitz"] = { { 74675, 90251 }, "FAIL_TYPE_MOVING", 90250, 90250, nil, false },
	["Fail_Grim Batol_General Umbriss_Ground Siege"] = { { 74634, 90249 }, "FAIL_TYPE_MOVING", 90249, 90249, true, true },
	["Fail_Grim Batol_Forgemaster Throngus_Burning Flames"] = { { 90764 }, "FAIL_TYPE_MOVING", 90764, 90764, nil, true },
	["Fail_Grim Batol_Forgemaster Throngus_Cave In"] = { { 90722 }, "FAIL_TYPE_MOVING", 90722, 90722, nil, true },
	["Fail_Grim Batol_Drahga Shadowburner_Shredding Swipe"] = { { 75271, 90966 }, "FAIL_TYPE_MOVING", 90966, 90966, nil, true },
	["Fail_Grim Batol_Drahga Shadowburner_Devouring Flames"] = { { 90949 }, "FAIL_TYPE_MOVING", 90950, 90950, nil, true },
	["Fail_Grim Batol_Drahga Shadowburner_Invocation of Flame"] = { { 75238, 90972 }, "FAIL_TYPE_MOVING", 75218, 75218, nil, true },
	["Fail_Grim Batol_Erudax, the Duke of Below_Shadow Gale"] = { { 91086, 91087, 75692, 75694 }, "FAIL_TYPE_MOVING", 91086, 91086, nil, true },

	["Fail_Halls of Origination_Temple Guardian Anhuur_Burning Light"] = { { 75117, 94951 }, "FAIL_TYPE_MOVING", 94951, 94951, nil, true },
	["Fail_Halls of Origination_Earthrager Ptah_Earth Spike"] = { { 89882 }, "FAIL_TYPE_MOVING", 89882, 89882, false, true },
	["Fail_Halls of Origination_Earthrager Ptah_Raging Smash"] = { { 83650 }, "FAIL_TYPE_WRONGPLACE", 83650, 83650, true, true },
	["Fail_Halls of Origination_Anraphet_Raging Inferno"] = { { 77262, 91159 }, "FAIL_TYPE_MOVING", 91159, 91159, nil, true }, -- trash
	["Fail_Halls of Origination_Anraphet_Alpha Beams"] = { { 76956, 91177 }, "FAIL_TYPE_MOVING", 76184, 76184, nil, true },
	["Fail_Halls of Origination_Isiset, Construct of Magic_Energy Flux"] = { { 74045, 89861 }, "FAIL_TYPE_MOVING", 89861, 89861, nil, true }, -- boss and trash
	["Fail_Halls of Origination_Ammunae, Construct of Life_Noxious Spores"] = { { 75702, 89889 }, "FAIL_TYPE_MOVING", 89889, 89889, nil, true },
	["Fail_Halls of Origination_Setesh, Construct of Destruction_Chaos Blast"] = { { 76681, 76684, 89875, 89874 }, "FAIL_TYPE_MOVING", 89875, 89875, nil, true },
	["Fail_Halls of Origination_Rajh, Construct of Sun_Inferno Leap"] = { { 87647, 89876 }, "FAIL_TYPE_MOVING", 87653, 87653, nil, false },
	["Fail_Halls of Origination_Rajh, Construct of Sun_Solar Winds"] = { { 74108, 89130 }, "FAIL_TYPE_MOVING", 89130, 89130, nil, true },

	["Fail_Lost City of the Tol'vir_General Husam_Shockwave"] = { { 83454, 90029 }, "FAIL_TYPE_MOVING", 91257, 91257, nil, true },
	["Fail_Lost City of the Tol'vir_General Husam_Mystic Trap"] = { { 83171, 91259 }, "FAIL_TYPE_MOVING", 91259, 91259, nil, true },
	["Fail_Lost City of the Tol'vir_High Prophet Barim_Heaven's Fury"] = { { 81942, 90040 }, "FAIL_TYPE_MOVING", 90040, 90040, nil, true },
	["Fail_Lost City of the Tol'vir_High Prophet Barim_Hallowed Ground"] = { { 88814, 90010 }, "FAIL_TYPE_MOVING", 90010, 90010, nil, true },
	["Fail_Lost City of the Tol'vir_High Prophet Barim_Blaze of the Heavens"] = { { 95249 }, "FAIL_TYPE_MOVING", 95248, 95248, nil, true },
	["Fail_Lost City of the Tol'vir_Lockmaw_Dust Flail"] = { { 81644, 90041 }, "FAIL_TYPE_MOVING", 90041, 90041, nil, false },
	["Fail_Lost City of the Tol'vir_Lockmaw_Whirlwind"] = { { 84785, 90012 }, "FAIL_TYPE_MOVING", 91408, 91408, nil, true },
	["Fail_Lost City of the Tol'vir_Siamat_Lightning Nova"] = { { 84544, 90015 }, "FAIL_TYPE_MOVING", 90015, 90015, nil, true },
	["Fail_Lost City of the Tol'vir_Siamat_Cloud Burst"] = { { 83051, 90032 }, "FAIL_TYPE_MOVING", 90032, 90032,  nil, true },
	["Fail_Lost City of the Tol'vir_Siamat_Tempest Storm"] = { { 83446, 90030 }, "FAIL_TYPE_MOVING", 90030, 90030, nil, true },

	["Fail_The Stonecore_Corborus_Flay"] = { { 79923 }, "FAIL_TYPE_WRONGPLACE", 79923, 79923, true, true }, -- trash
	["Fail_The Stonecore_Corborus_Crystal Barrage"] = { { 86881, 92648 }, "FAIL_TYPE_MOVING", 92648, 92648, nil, true },
	["Fail_The Stonecore_Corborus_Thrashing Charge"] = { { 92651 }, "FAIL_TYPE_MOVING", 92651, 92651, nil, false },
	["Fail_The Stonecore_Slabhide_Lava Fissure"] = { { 80803, 92657, 92658 }, "FAIL_TYPE_MOVING", 80803, 80803, nil, true },
	--["Fail_The Stonecore_Slabhide_Stalactite"] = { { 80647, 92309 }, "FAIL_TYPE_MOVING", 80643, 80643, nil, true }, -- no combat log event?
	["Fail_The Stonecore_Slabhide_Crystal Storm"] = { { 92300 }, "FAIL_TYPE_MOVING", 92265, 92265, nil, true },
	["Fail_The Stonecore_Ozruk_Ground Slam"] = { { 92410, 95338, 92381 }, "FAIL_TYPE_MOVING", 92381, 92381, nil, false },
	["Fail_The Stonecore_Ozruk_Shatter"] = { { 92662, 95347 }, "FAIL_TYPE_MOVING", 92662, 92662, nil, false },
	["Fail_The Stonecore_High Priestess Azil_Energy Shield"] = { { 79050, 82858, 92667 }, "FAIL_TYPE_MOVING", 92667, 92667, nil, true },
	["Fail_The Stonecore_High Priestess Azil_Seismic Shard"] = { { 79021, 92665 }, "FAIL_TYPE_MOVING", 92665, 92665, nil, false },
	["Fail_The Stonecore_High Priestess Azil_Gravity Well"] = { { 79249 }, "FAIL_TYPE_MOVING", 79249, 79249, nil, true },

	["Fail_The Vortex Pinnacle_Grand Vizier Ertan_Cyclone Shield"] = { { 86292, 93991 }, "FAIL_TYPE_MOVING", 93991, 93991 },
	["Fail_The Vortex Pinnacle_Altairus_Lightning Blast"] = { { 88357, 93988 }, "FAIL_TYPE_MOVING", 93988, 93988, nil, true },
	["Fail_The Vortex Pinnacle_Asaad, Caliph of Zephyrs_Supremacy of the Storm"] = { { 87553, 93994 }, "FAIL_TYPE_MOVING", 93994, 93994, nil, true },

	["Fail_The Deadmines_Glubtok_Fire Wall"] = { { 91397 }, "FAIL_TYPE_MOVING", 91398, 91398, nil, true },
	["Fail_The Deadmines_Glubtok_Fire Blossom"] = { { 88173, 91275 }, "FAIL_TYPE_MOVING", 91275, 91275, nil, true },
	["Fail_The Deadmines_Glubtok_Frost Blossom"] = { { 88177, 91274 }, "FAIL_TYPE_MOVING", 91274, 91274, nil, true },
	["Fail_The Deadmines_Glubtok_Nightmare Flames"] = { { 92171 }, "FAIL_TYPE_MOVING", 92171, 92171, nil, true },
	["Fail_The Deadmines_Glubtok_Ice Shards"] = { { 92203 }, "FAIL_TYPE_MOVING", 92203, 92203, nil, true },
	["Fail_The Deadmines_Helix Gearbreaker_Sticky Bomb"] = { { 88974, 91566 }, "FAIL_TYPE_MOVING", 91566, 91566, nil, true },
	["Fail_The Deadmines_Foe Reaper 5000_Harvest"] = { { 88501, 91719 }, "FAIL_TYPE_MOVING", 88495, 88495, nil, true },
	["Fail_The Deadmines_Foe Reaper 5000_Reaper Strike"] = { { 88490, 91717 }, "FAIL_TYPE_WRONGPLACE", 91717, 91717, true, true },
	["Fail_The Deadmines_Foe Reaper 5000_Spark"] = { { 92278 }, "FAIL_TYPE_MOVING", 92278, 92278, nil, true },
	["Fail_The Deadmines_Admiral Ripsnarl_Swipe"] = { { 88839, 91859 }, "FAIL_TYPE_WRONGPLACE", 91859, 91859, true, true },
	["Fail_The Deadmines_\"Captain\" Cookie_Cauldron Fire"] = { { 89262, 92752 }, "FAIL_TYPE_WRONGPLACE", 92752, 92752, nil, true },
	["Fail_The Deadmines_\"Captain\" Cookie_Rotten Aura"] = { { 89735, 92065 }, "FAIL_TYPE_WRONGPLACE", 92065, 92065, nil, true },
	["Fail_The Deadmines_\"Captain\" Cookie_Nauseated"] = { { 89732, 92066 }, "FAIL_TYPE_WRONGPLACE", 92066, 92066, nil, true },
	["Fail_The Deadmines_Vanessa VanCleef_Fiery Blaze"] = { { 6297, 93485 }, "FAIL_TYPE_MOVING", 93485, 93485, nil, true },
	["Fail_The Deadmines_Vanessa VanCleef_Powder Explosion"] = { { 96283 }, "FAIL_TYPE_MOVING", 96283, 96283, nil, true },

	["Fail_Shadowfang Keep_Commander Springvale_Shield of the Perfidious"] = { { 93722, 93737 }, "FAIL_TYPE_WRONGPLACE", 93737, 93737, true, true },
	["Fail_Shadowfang Keep_Commander Springvale_Desecration"] = { { 93691, 94370 }, "FAIL_TYPE_MOVING", 93687, 93687, true, true },
	["Fail_Shadowfang Keep_Lord Walden_Ice Shards"] = { { 93535, 93527, 93703 }, "FAIL_TYPE_MOVING", 93527, 93527, nil, true },
	["Fail_Shadowfang Keep_Lord Walden_Toxic Coagulant"] = { { 93617 }, "FAIL_TYPE_MOVING", 93617, 93617, nil, true },
	["Fail_Shadowfang Keep_Lord Godfrey_Pistol Barrage"] = { { 93564, 93784 }, "FAIL_TYPE_MOVING", 93520, 93520, nil, true },

	["Fail_Zul'Aman_Akil'zon_Electrical Storm"] = { { 43657, 97300 }, "FAIL_TYPE_MOVING", 97300, 97300, nil, true },
	["Fail_Zul'Aman_Nalorakk_Surge"] = { { 42402 }, "FAIL_TYPE_MOVING", 42402, 42402, nil, true },
	["Fail_Zul'Aman_Jan'alai_Flame Breath"] = { { 43140, 97497, 97855 }, "FAIL_TYPE_MOVING", 43140, 43140, nil, true },
	["Fail_Zul'Aman_Jan'alai_Fire Bomb"] = { { 42630 }, "FAIL_TYPE_MOVING", 42630, 42630, nil, true },
	["Fail_Zul'Aman_Jan'alai_Fire Wall"] = { { 43114 }, "FAIL_TYPE_MOVING", 43114, 43114 },
	["Fail_Zul'Aman_Hex Lord Malacrass_Death and Decay"] = { { 61603 }, "FAIL_TYPE_MOVING", 61603, 61603, nil, true },
	["Fail_Zul'Aman_Hex Lord Malacrass_Rain of Fire"] = { { 43440 }, "FAIL_TYPE_MOVING", 95438, 95438, nil, true },
	["Fail_Zul'Aman_Hex Lord Malacrass_Whirlwind"] = { { 43442 }, "FAIL_TYPE_MOVING", 43442, 43442, nil, true },
	["Fail_Zul'Aman_Hex Lord Malacrass_Consecrate"] = { { 43429 }, "FAIL_TYPE_MOVING", 43429, 43429, nil, true },
	["Fail_Zul'Aman_Hex Lord Malacrass_Fire Nova Totem"] = { { 43464 }, "FAIL_TYPE_SWITCHING", 43436, 43436, nil, false },
	["Fail_Zul'Aman_Daakara_Burn"] = { { 43217, 97682, 95660  }, "FAIL_TYPE_MOVING", 97682, 97682, nil, true },

	["Fail_Zul'Gurub_High Priest Venoxis_Bloodvenom"] = { { 96638, 97104 }, "FAIL_TYPE_MOVING", 97104, 97104, nil, true },
	["Fail_Zul'Gurub_High Priest Venoxis_Venomous Effusion"] = { { 96685, 97338 }, "FAIL_TYPE_MOVING", 97338, 97338, nil, true },
	["Fail_Zul'Gurub_High Priest Venoxis_Breath of Hethiss"] = { { 96744, 96752, 97084, 97330 }, "FAIL_TYPE_MOVING", 96744, 96744, nil, true },
	["Fail_Zul'Gurub_High Priest Venoxis_Pool of Acrid Tears"] = { { 96521, 96755, 97085, 97089 }, "FAIL_TYPE_MOVING", 96521, 96521, nil, true },
	["Fail_Zul'Gurub_Bloodlord Mandokir_Devastating Slam"] = { { 96743 }, "FAIL_TYPE_MOVING", 96740, 96740 },
	["Fail_Zul'Gurub_Cache of Madness - Wushoolay_Lightning Rod"] = { { 96698, 96699 }, "FAIL_TYPE_MOVING",  96699, 96699 },
	["Fail_Zul'Gurub_Cache of Madness - Wushoolay_Lightning Cloud"] = { { 96710, 96711 }, "FAIL_TYPE_MOVING", 96711, 96711, nil, true },
	["Fail_Zul'Gurub_High Priestess Kilnara_Yoga Flame"] = { { 97352 }, "FAIL_TYPE_MOVING", 97352, 97352, nil, true },
	["Fail_Zul'Gurub_High Priestess Kilnara_Wave of Agony"] = { { 96460 }, "FAIL_TYPE_MOVING", 96460, 96460, nil, false },
	["Fail_Zul'Gurub_Zanzil_Zanzili Fire"] = { { 96914, 96916 }, "FAIL_TYPE_MOVING", 96914, 96914, nil, true },
	["Fail_Zul'Gurub_Zanzil_Zanzil's Graveyard Gas"] = { { 96335, 96434 }, "FAIL_TYPE_MOVING", 96434, 96434, nil, true },
	["Fail_Zul'Gurub_Jin'do the Godbreaker_Shadows of Hakkar"] = { { 97173 }, "FAIL_TYPE_MOVING", 97173, 97173, nil, false },
	["Fail_Zul'Gurub_Jin'do the Godbreaker_Shadow Spike"] = { { 97161 }, "FAIL_TYPE_MOVING", 97161, 97161, nil, false },

	["Fail_Dragon Soul_Morchok_Black Blood of the Earth"] = { { 108570, 103785, 110287, 110288 }, "FAIL_TYPE_MOVING", 103785, 103785, nil, true },
	["Fail_Dragon Soul_Warlord Zon'ozz_Psychic Drain"] = { { 104322, 104323, 104606, 104607, 104608 }, "FAIL_TYPE_WRONGPLACE", 104322, 104322, true, nil },
	["Fail_Dragon Soul_Hagara the Stormbinder_Ice Wave"] = { { 105314 }, "FAIL_TYPE_MOVING", 105314, 105314, nil, false },
	["Fail_Dragon Soul_Hagara the Stormbinder_Ice Shards"] = { { 69425 }, "FAIL_TYPE_MOVING", 69425, 69425, nil, false },
	["Fail_Dragon Soul_Hagara the Stormbinder_Storm Pillar"] = { { 109565, 109566, 109564, 109563 }, "FAIL_TYPE_MOVING", 109563, 109563, nil, false },
	["Fail_Dragon Soul_Ultraxion_Hour of Twilight"] = { { 103327 }, "FAIL_TYPE_CASTING", 103327, 103327, nil, true },
	["Fail_Dragon Soul_Spine of Deathwing_Nuclear Blast"] = { { 105845 }, "FAIL_TYPE_WRONGPLACE", 105845, 105845, nil, false },
	["Fail_Dragon Soul_Warmaster Blackhorn_Blade Rush"] = { { 109015, 107595, 109013, 109014 }, "FAIL_TYPE_MOVING", 109015, 109015, nil, true },
	["Fail_Dragon Soul_Warmaster Blackhorn_Shockwave"] = { { 108046 }, "FAIL_TYPE_MOVING", 108046, 108046, nil, true },

}

-- Populate failEvents with simple fails so we don't have to add them more than once
-- ... in case we decide to add more general fail types
local function PopulateFailEvents(...)
	for i=1, select("#", ...) do
		for k, v in pairs(select(i, ...)) do
			failEvents[k] = v
		end
	end
end
PopulateFailEvents(generalDamageFail)

local function TableLookup(item, table)
	for i=1, #table do
		if table[i] == item then return i end
	end
	return false
end

local zoneList, bossList, zoneBosses = {}, {}, {}
for k, v in pairs(failEvents) do
	local s = k:match("_.*_"):match("[^_].*[^_]")
	local z = s:match(".*_"):gsub("_","")
	local b = s:match("_.*"):gsub("_","")

	if not zoneList[z] then zoneList[z] = {} end
	table.insert(zoneList[z], k)

	if not bossList[b] then bossList[b] = {} end
	table.insert(bossList[b], k)

	if not zoneBosses[z] then zoneBosses[z] = {} end
	if not TableLookup(b, zoneBosses[z]) then table.insert(zoneBosses[z], b) end
end

local corruptionCasted

local debuffs = {
	(GetSpellInfo(77786)), -- Consuming Flames
	(GetSpellInfo(79339)), -- Explosive Cinders
	(GetSpellInfo(99516)), -- Countdown
	(GetSpellInfo(109033)), -- Stomp
}

local buffs = {
	(GetSpellInfo(91545)), -- Power Conversion
	(GetSpellInfo(91449)), -- Unstable Shield
	(GetSpellInfo(91518)), -- Barrier
	(GetSpellInfo(91503)), -- Poison Soaked Shell
}

local barrierSpellIdExceptions = {
	[26364] = true, -- Lightning Shield
	[2643] = true, -- multishot
	[83077] = true, -- improved serpent sting
	[44461] = true, -- living bomb (the SPELL_DAMAGE spellId)
}

local deepCorruptionSpellIdExceptions = {
	[633]   = true,	--"Lay on Hands"
	[6262]  = true,	--"Healthstone"
	[81269] = true,	--"Efflorescence"
	[52042] = true,	--"Healing Stream Totem"
	[98021] = true,	--"Spirit Link"
	[53652] = true,	--"Beacon of Light"
	[85673] = true,	--"Word of Glory"
	[77489] = true,	--"Echo of Light"
	[33110] = true,	--"Prayer of Mending"
	[34299] = true,	--"Leader of the Pack"
	[53353] = true,	--"Chimera Shot"
	[15290] = true,	--"Vampiric Embrace"
	[73651] = true,	--"Recuperate"
	[96379] = true,	--"Fel Armor"
}

-- /print "[\""..GetMapNameByID(GetCurrentMapAreaID()).."\"] = "..GetCurrentMapAreaID()
local usedZoneIDs = {
	["Blackrock Caverns"] = 753,
	["The Deadmines"] = 756,
	["Grim Batol"] = 757,
	["Halls of Origination"] = 759,
	["Lost City of the Tol'vir"] = 747,
	["Shadowfang Keep"] = 764,
	["The Stonecore"] = 768,
	["Throne of the Tides"] = 767,
	["The Vortex Pinnacle"] = 769,

	["Zul'Aman"] = 781,
	["Zul'Gurub"] = 793,

	["Baradin Hold"] = 752,
	["The Bastion of Twilight"] = 758,
	["Blackwing Descent"] = 754,
	["Throne of the Four Winds"] = 773,
	["Firelands"] = 800,
	["Dragon Soul"] = 824,
}

-- Tank Fail Position in failEvents
local TFP = 5
-- overkill only position in failEvents
local OKP = 6

-------------------------------------------------------------------------
-- API CALLS
-------------------------------------------------------------------------

--- Get a list of supported events.
-- @see failEvents page
-- @return a table of event names which can be fired
function lib:GetSupportedEvents()
	local t = {}
	for k, v in pairs(failEvents) do
		table.insert(t, k)
	end
	return t
end

--- Get a list of supported events in the given zone
-- @see failEvents page
-- @return a table of event names which can be fired in the zone
function lib:GetSupportedZoneEvents(zone) return zoneList[zone] end

--- Get a list of supported events at the given boss
-- @see failEvents page
-- @return a table of event names which can be fired at the boss
function lib:GetSupportedBossEvents(boss) return bossList[boss] end

--- Get a List of Bosses at the given zone for the supported events
-- @see failEvents page
-- @return a table of boss names at the given zone for the supported events
function lib:GetSupportedZoneBosses(zone) return zoneBosses[zone] end

--- Get a List of supported Zones
-- @see failEvents page
-- @return a table of zone names that are supported
function lib:GetSupportedZones()
	local t = {}
	for k, v in pairs(zoneList) do
		table.insert(t, k)
	end
	return t
end

--- Get a fail events localized name
-- @see failEvents page
-- @param event the event name
-- @return a fail events localized name
function lib:GetEventName(event)
        local v = event and failEvents[event]
	if not v then
	  	return nil
	elseif type(v[3]) == "number" then
		return (GetSpellInfo(v[3]))
	else
		return v[3]
	end
end

--- Get a fail events localized name, including a spell link when possible
-- @see failEvents page
-- @param event the event name
-- @return a fail events fancy name
function lib:GetEventFancyName(event)
        local v = event and failEvents[event]
	if not v then
	  	return nil
	elseif type(v[3]) == "number" then
		return (GetSpellLink(v[3]))
	else
		return v[3]
	end
end

--- Get a fail events description
-- @see failEvents in the code
-- @param event the event name
-- @return a description somewhat related to the fail event
function lib:GetEventDescription(event)
        local v = event and failEvents[event]
	if not v then
	  	return nil
	elseif type(v[4]) == "number" then
		return lib:getSpellDescription(v[4])
	else
		return v[4]
	end
end

--- Get a tabe of constraints with their default values for the event
-- @see lib.CONSTRAINTS
-- @param event the event name
-- @return a table with ["Constraint Name"] = value pairs or returns nil if no constraints
function lib:GetEventConstraints(event)
	return event and lib.CONSTRAINTS[event]
end

--- Returns true if there is an option for tanks not failing on the event
-- @see lib.TANKS_DONT_FAIL_LIST
-- @param event the event name
-- @return true if there is an option for tanks not failing on the event
function lib:GetTanksDontFailOption(event)
        local v = event and failEvents[event]
	if not v then
	  	return nil
	elseif v[TFP] then
		return true
	else
		return false
	end
end

--- Returns true if there is an option for overkill only
-- @see lib.OVERKILL_ONLY_LIST
-- @param event the event name
-- @return true if there is an option for overkill only on the event
function lib:GetOverkillOnlyOption(event)
        local v = event and lib.OVERKILL_ONLY_LIST[event]
	if v or v == false then
	  	return true
	else
		return false
	end
end

--- Returns the localized zone name from a supported zone
-- @see localization strings
-- @param zone the zone name to get localized zone for
-- @return the localized zone name
function lib:GetLocalizedZone(zone)
 	if not zone then return nil end
	if not zoneList[zone] then
		return "Localization not found"
	else
		return GetMapNameByID(usedZoneIDs[zone])
	end
end

--- Returns the localized boss name for a supported boss
-- @see localization strings or the encounter journal
-- @param boss the boss to get localized boss for
-- @return the localized boss name
function lib:GetLocalizedBoss(boss)
 	if not boss then return nil end
	if not bossList[boss] then
		return "Localization not found"
	else
		local name = LEJB:GetEncounterInfoByBossName(boss)
		return name or "Localization not found"
	end
end

--- Returns the localized constraint name of the given constraint in the given fail event
-- @see lib.CONSTRAINTS
-- @param event, constraint the fail event and the constraint
-- @return the localized constraint name in the given fail event
function lib:GetLocalizedConstraint(event, constraint)
	if not event or not constraint then return nil end
	local v = lib.CONSTRAINTS[event]
	if v and v[constraint] then
		return L[constraint]
	else
		return nil
	end
end

-------------------------------------------------------------------------
-- UTILITY
-------------------------------------------------------------------------

do
	local cache = {}
	local scanner = CreateFrame("GameTooltip")
	scanner:SetOwner(WorldFrame, "ANCHOR_NONE")
	local lCache, rCache = {}, {}
	for i = 1, 4 do
		lCache[i], rCache[i] = scanner:CreateFontString(), scanner:CreateFontString()
		lCache[i]:SetFontObject(GameFontNormal); rCache[i]:SetFontObject(GameFontNormal)
		scanner:AddFontStrings(lCache[i], rCache[i])
	end
	function lib:getSpellDescription(spellId)
		if cache[spellId] then return cache[spellId] end
		scanner:ClearLines()
		scanner:SetHyperlink("spell:"..spellId)
		for i = scanner:NumLines(), 1, -1  do
			local desc = lCache[i] and lCache[i]:GetText()
			if desc then
				cache[spellId] = desc
				return desc
			end
		end
	end
end

function lib:IsRaidPet(unit)
	for i=1, 25 do
		if UnitIsUnit(("raid%dpet"):format(i),unit) then
			-- if its a raid pet return the owner
			return UnitName(("raid%d"):format(i))
		end
	end
	return false
end

function lib:IsTank(unit)
	-- 1. check blizzard tanks first
	-- 2. check blizzard roles second
	-- 3. finally check LGT for talent guess
	if GetPartyAssignment("MAINTANK", unit, 1) then
		return true
	end
	if UnitGroupRolesAssigned(unit) == "TANK" then
		return true
	end
	local role = LGT:GetUnitRole(unit)
	if role and (role == "tank") then
		return true
	end
	return false
end

function lib:IsDebuffed(target)
	for _, debuff in ipairs(debuffs) do
		if debuff == UnitDebuff(target, debuff) then return true end
	end
	return false
end

function lib:IsBuffed(target)
	for _, buff in ipairs(buffs) do
		if buff == UnitBuff(target, buff) then return true end
	end
	return false
end

function lib:GetMobId(GUID)
	if not GUID then return end
	return tonumber(GUID:sub(7, 10), 16)
end

function lib:findTargetByGUID(id)
	local idType = type(id)
	for i, unit in next, lib.targetlist do
		if UnitExists(unit) and not UnitIsPlayer(unit) then
			local unitId = UnitGUID(unit)
			if idType == "number" then unitId = tonumber(unitId:sub(7, 10), 16) end
			if unitId == id then return unit end
		end
	end
end

do
	frame:Hide()
	frame:SetScript("OnUpdate", function(self, elapsed)
		for name, timer in pairs(lib.timers) do
			timer.elapsed = timer.elapsed + elapsed
			if timer.elapsed > timer.delay then
				timer.func()
				lib:CancelTimer(name)
			end
		end
	end)
end

function lib:ScheduleTimer(name, func, delay)
	if not self.timers then self.timers = {} end
	self.timers[name] = {
		elapsed = 0,
		func = func,
		delay = delay,
	}

	if not frame:IsShown() then frame:Show() end
end

function lib:CancelTimer(name)
	if not name then
		self.timers = {}
		return frame:Hide()
	end

	self.timers[name] = nil
	if not next(self.timers) then self:CancelTimer() end
end

function lib:IsTimerRunning(name)
	return (self.timers and self.timers[name]) and true or false
end

-- param spellId, table
function lib:SpellIdCheck(spellId, table)
        if not table.index then
	  local index = {}
	  for k, v in pairs(table) do
		for i=1, #v[1] do
		  local id = v[1][i]
		  if index[id] then
		    print("ERROR duplicate spellid: "..id)
		  else
		    index[id] = k
		  end
		end
	  end
	  table.index = index
	end
	local k = table.index[spellId]
	if k then
	  return k, unpack(table[k], 2)
	else
	  return false
	end
end

-- range check
function lib:RangeCheck(player)
	local num = GetNumRaidMembers()
	local diff = GetRaidDifficulty()
	for i=1, num do
		local name, _, subgroup = GetRaidRosterInfo(i)
		if name == player then
			if diff == 2 or diff == 4 then
				if subgroup > 5 then return false end
			else
				if subgroup > 2 then return false end
			end
		end
	end
	return true
end

-- returns true if it handled an event
function lib:GeneralDamageFail(spellId, destName, damage, overkill, timestamp)
	local failName, failType = lib:SpellIdCheck(spellId, generalDamageFail)
	if not failName then
		return false
	end

	if overkill > 0 then -- if its an overkill
		self:Antispam(true, 5, nil, failName, destName, failType, timestamp) -- thats a fail either way
	end
	if lib.OVERKILL_ONLY_LIST[failName] or lib.OVERKILL_ONLY_LIST.ovkoverride then return true end -- if its only overkill we can stop here
	if failName and self.CONSTRAINTS[failName] then -- the fail has a damage constraint
		if damage > self.CONSTRAINTS[failName]["Damage Constraint"] then -- if damage is higher than constraint value
			self:Antispam(true, 5, nil, failName, destName, failType, timestamp)
		end
	else -- if it has no damage constraint
		if damage > 0 then
			self:Antispam(true, 5, nil, failName, destName, failType, timestamp)
		end
	end
	return true
end

function lib:Antispam(type, min, max, failName, destName, failType, timestamp, ...)
	local deltaT = timestamp - (self.LastEvent[failName][destName] or 0)
	if type then -- Initial damage allowed
		if deltaT > min then -- min time has to pass between two fails
			self:FailEvent(failName, destName, self[failType], ...)
		end
	else -- Initial damage not allowed
		 -- at leat min time has to pass between fails but cant be more than max
		if deltaT > min and deltaT < max then
			self:FailEvent(failName, destName, self[failType], ...)
		end
	end
	self.LastEvent[failName][destName] = timestamp
	return
end

-------------------------------------------------------------------------
-- Initialization
-------------------------------------------------------------------------

function lib:InitVariables()
	if not self.active then return end

	self.RaidTable = {}

	self:InitRaidTable()

	self.LastEvent = {}

	self.targetlist = {"target", "targettarget", "focus", "focustarget", "mouseover", "mouseovertarget"}
	for i = 1, 4 do table.insert(self.targetlist, string.format("boss%d", i)) end
	for i = 1, 4 do table.insert(self.targetlist, string.format("party%dtarget", i)) end
	for i = 1, 40 do table.insert(self.targetlist, string.format("raid%dtarget", i)) end

	-- Last whatever
	for k, v in pairs(failEvents) do
		self.LastEvent[k] = {}
	end

end

function lib:InitRaidTable()
	--if next(lib.RaidTable) then return end -- WTF WAS THIS?
	local difficulty = GetRaidDifficulty()

	for raidindex = 1, GetNumRaidMembers() do
		local name, _, group, _, _, _, _, online = GetRaidRosterInfo(raidindex)
		if difficulty <= 2 and group <= 2 and online then -- 10 man
			lib.RaidTable[name] = false
		elseif group <= 5 and online then -- 25 man
			lib.RaidTable[name] = false
		end
	end
end

-------------------------------------------------------------------------
-- Globals
-------------------------------------------------------------------------

lib.FAIL_TYPE_NOTMOVING		= L["not moving"] -- fails at not moving with probably something on him that triggers on movement
lib.FAIL_TYPE_MOVING		= L["moving"] -- fails at moving out of shit
lib.FAIL_TYPE_NOTSPREADING	= L["not spreading"] -- fails at standing together (think auriaya)
lib.FAIL_TYPE_SPREADING		= L["spreading"] -- fails at not having enough distance between people
lib.FAIL_TYPE_DISPELLING	= L["dispelling"] -- fails at not dispelling something you should be dispelling (not very usable yes, but for completeness)
lib.FAIL_TYPE_NOTDISPELLING	= L["not dispelling"] -- fails at dispelling something you should NOT be dispelling
lib.FAIL_TYPE_WRONGPLACE	= L["not being at the wrong place"] -- fails at not being in the wrong place in the wrong time (cleave, etc)
lib.FAIL_TYPE_NOTCASTING	= L["not casting"] -- casting spells when you shouldnt have
lib.FAIL_TYPE_NOTATTACKING	= L["not attacking"] -- attacking when you shouldnt have
lib.FAIL_TYPE_CASTING		= L["casting"] -- not casting spells when you should have (think malygos phase3, or bloodqueen not biting when you should)
lib.FAIL_TYPE_SWITCHING		= L["switching"] -- not taunting/switching tanks when you're supposed to

-- ### Make sure when you add a new constraint type that it has a localization entry
-- ### remember to remove debug events
--- Default constraints
-- @class table
-- @name lib.CONSTRAINTS
-- @field Description the table holding ["Constraint Type"] = value pairs for failEvents
lib.CONSTRAINTS = {
	--["Fail_Glob -'bal_Maat_HL"] = { ["Damage Constraint"] = 10, ["Tick Constraint"] = 5 },
	["Fail_Blackwing Descent_Magmaw_Pillar of Flame"] = { ["Damage Constraint"] = 40000 },
	["Fail_The Bastion of Twilight_Ascendant Council_Glaciate"] = { ["Damage Constraint"] = 40000 },
	["Fail_The Bastion of Twilight_Theralion and Valiona_Devouring Flames"] = { ["Damage Constraint"] = 50000 },
	["Fail_The Bastion of Twilight_Theralion and Valiona_Twilight Meteorite"] = { ["Damage Constraint"] = 50000 },
	["Fail_Blackwing Descent_Nefarian's End_Magma"] = { ["Tick Constraint"] = 5 },
	["Fail_Blackwing Descent_Maloriak_Dark Sludge"] = { ["Damage Constraint"] = 400000 },
	["Fail_Blackwing Descent_Omnotron Defense System_Chemical Cloud"] = { ["Time Constraint - Low"] = 5, ["Time Constraint - High"] = 8},
	["Fail_Firelands_Ragnaros_Molten Seed"] = { ["Damage Constraint"] = 50000 },
	["Fail_Firelands_Majordomo Staghelm_Leaping Flames"] = { ["Time Constraint - Low"] = 2, ["Time Constraint - High"] = 5},
	["Fail_Firelands_Majordomo Staghelm_Burning Orb"] = { ["Tick Constraint"] = 6 },
	["Fail_Firelands_Baleroc, the Gatekeeper_Torment"] = { ["Tick Constraint"] = 15 },
	["Fail_Zul'Gurub_Jin'do the Godbreaker_Shadows of Hakkar"] = { ["Damage Constraint"] = 50000 },
	["Fail_Dragon Soul_Warmaster Blackhorn_Twilight Flames"] = { ["Time Constraint - Low"] = 3, ["Time Constraint - High"] = 5},
}

--- Default tanks dont fail list
-- @class table
-- @name lib.TANKS_DONT_FAIL_LIST
-- @see lib:GetTanksDontFailOption()
-- @field Description the table holding [event] = tanks-dont-fail setting pairs for failEvents. The value is true to suppress fails on tanks for supported events
lib.TANKS_DONT_FAIL_LIST = {}
for k, v in pairs(failEvents) do
	 if v[TFP] then
		lib.TANKS_DONT_FAIL_LIST[k] = true
	end
end

--- Default overkill only list
-- @class table
-- @name lib.OVERKILL_ONLY_LIST
-- @see lib:GetOverkillOnlyOption()
-- @field Description the table holding [event] = overkill-only setting pairs for failEvents. The value is true to only report supported events when they are a killing blow.
lib.OVERKILL_ONLY_LIST = {}
for k, v in pairs(failEvents) do
	if v[OKP] then
		lib.OVERKILL_ONLY_LIST[k] = true
	elseif v[OKP] == false then
		lib.OVERKILL_ONLY_LIST[k] = false
	end
end

-------------------------------------------------------------------------
-- EVENT HANDLING
-------------------------------------------------------------------------

do
	local _, etype, f

	frame:SetScript("OnEvent", function (self, event, ...)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			_, etype = ...
			if etype == "SPELL_MISSED" then  -- lets hack the misses onto the damage event
				local timestamp, _, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, missType,  amountMissed = ...
				local damage, overkill = 0, 0

				lib.SPELL_DAMAGE(lib, timestamp, etype, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, damage, overkill, missType, amountMissed)

				return
			end

			f = lib[etype]

			if f then
				f(lib, ...)
			end

			return
		end

		f = lib[event]

		if f then
			f(lib, ...)
		end

	end)
end

function lib:FailEvent(event, playerName, failType, ...)
	if lib.TANKS_DONT_FAIL_LIST[event] and lib:IsTank(playerName) then return end
	if not lib:RangeCheck(playerName) then return end
	-- Don't fire if one of the arguments are missing
	if not playerName or playerName=="" or not failType or failType=="" or not event or event=="" then return end
	callbacks:Fire(event, playerName, failType, ...)
	callbacks:Fire("AnyFail", event, playerName, failType, ...)
end

function lib:GoActive()
	if self.active then return end

	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	frame:RegisterEvent("PLAYER_REGEN_ENABLED")
	frame:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	self:InitVariables()

	self.active = true

	callbacks:Fire("Fail_Active")
end

function lib:GoInactive()
	if not self.active then return end

	self:InitVariables()

	self.active = nil

	frame:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	frame:UnregisterEvent("PLAYER_REGEN_ENABLED")

	callbacks:Fire("Fail_Inactive")
end

function lib:checkActive()
        local _,t = IsInInstance()
	if (t == "raid" or t == "party") then
		local oldmapid = GetCurrentMapAreaID()
		SetMapToCurrentZone()
		local mapid = GetCurrentMapAreaID()
		SetMapByID(oldmapid)
		for _,id in pairs(usedZoneIDs) do
		  if mapid == id then
			self:GoActive()
			return
		  end
		end
	end
	self:GoInactive()
end

lib.active = true
lib:GoInactive()
lib:checkActive()

function lib:PLAYER_ENTERING_WORLD()
	self:checkActive()
end

function lib:ZONE_CHANGED()
	self:checkActive()
end

function lib:PLAYER_REGEN_ENABLED()
	self:InitVariables()
end

function lib:CHAT_MSG_RAID_BOSS_EMOTE(message, sourceName, language, channelName, destName, ...)
	if message:find(L["rolls left"]) or message:find(L["rolls right"]) then
		for i = 1, GetNumRaidMembers() do
			local n, _, g = GetRaidRosterInfo(i)
			-- do some checks for 25/10 man raid size so we don't warn for ppl who are not in the instance
			if (GetInstanceDifficulty() == 1 and g < 3) or (GetInstanceDifficulty() == 3 and g < 3) or (GetInstanceDifficulty() == 2 and g < 6) or (GetInstanceDifficulty() == 4 and g < 6) then
				if not UnitDebuff(n, (GetSpellInfo(109454))) and not UnitIsDeadOrGhost(n) then -- nor hooked, most likely will die
					self:FailEvent("Fail_Dragon Soul_Spine of Deathwing_Barrel Roll",n,self["FAIL_TYPE_WRONGPLACE"])
				end
			end
		end
	end
end

function lib:SPELL_DAMAGE(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, damage, overkill)
	if bit.band(sourceFlags or 0, COMBATLOG_OBJECT_TYPE_GUARDIAN) > 0 or bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_GUARDIAN) > 0 or not spellId then return end
	-- Guardian activities ignored after this point
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	damage = damage ~= "ABSORB" and damage or 0
	overkill = overkill or 0

	if isPlayerEvent and lib:GeneralDamageFail(spellId, destName, damage, overkill, timestamp) then return end

	if corruptionCasted and (destName == EJ_GetSectionInfo(3920)) then -- corruption from EJ
		lib.RaidTable[sourceName] = true
	end

	local destUnitID = lib:findTargetByGUID(destGUID)
	if destUnitID and lib:IsBuffed(destUnitID) and not barrierSpellIdExceptions[spellId] then
		if UnitIsUnit("boss1",destUnitID) or UnitIsUnit("boss2",destUnitID) or UnitIsUnit("boss3",destUnitID) or UnitIsUnit("boss4",destUnitID) then
			if lib:IsRaidPet(sourceName) then
				lib:Antispam(true, 5, nil, "Fail_Blackwing Descent_Omnotron Defense System_Barrier", lib:IsRaidPet(sourceName), "FAIL_TYPE_NOTATTACKING", timestamp, sourceName.." - "..spellName)
			else
				lib:Antispam(true, 5, nil, "Fail_Blackwing Descent_Omnotron Defense System_Barrier", sourceName, "FAIL_TYPE_NOTATTACKING", timestamp, spellName)
			end
		end
	end

	-- Doomguard's Doom Bolt, Imp's Firebolt
	if spellId == 85692 or spellId == 3110 then
		if lib:IsRaidPet(sourceName) and isPlayerEvent and GetZoneText() == lib:GetLocalizedZone("Fail_Blackwing Descent_Nefarian's End_Stolen Power") then
			lib:Antispam(true, 3, nil, "Fail_Blackwing Descent_Nefarian's End_Stolen Power", UnitName(lib:IsRaidPet(sourceName)), "FAIL_TYPE_NOTATTACKING", timestamp)
		end
	end

	if spellName == (GetSpellInfo(94113)) then -- lightning discharge
		self.LastEvent["Lightning Discharge"] = timestamp
	end

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if (lib.OVERKILL_ONLY_LIST[failName] or lib.OVERKILL_ONLY_LIST.ovkoverride) and overkill <= 0 then
		  return
		end
		if failName == "Fail_The Bastion of Twilight_Theralion and Valiona_Deep Breath" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Theralion and Valiona_Twilight Meteorite" and damage > self.CONSTRAINTS[failName]["Damage Constraint"] then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Ascendant Council_Lava Plume" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Ascendant Council_Flame Strike" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Theralion and Valiona_Devouring Flames" and damage > self.CONSTRAINTS[failName]["Damage Constraint"] then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Magmaw_Massive Crash" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Ascendant Council_Flame Torrent" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Nefarian's End_Shadow Of Cowardice" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Magmaw_Pillar of Flame" and damage > self.CONSTRAINTS[failName]["Damage Constraint"] then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Magmaw_Ignition" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Maloriak_Scorching Blast" then
			if lib:IsDebuffed(destName) and damage > 0 then
				self:FailEvent("Fail_Blackwing Descent_Maloriak_Consuming Flames",destName,self.FAIL_TYPE_MOVING)
				return
			else
				self.RaidTable[destName] = timestamp
			end
		elseif failName == "Fail_Blackwing Descent_Omnotron Defense System_Chemical Cloud" then
			lib:Antispam(false, self.CONSTRAINTS[failName]["Time Constraint - Low"] , self.CONSTRAINTS[failName]["Time Constraint - High"] , failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Omnotron Defense System_Flamethrower" then
			if self.LastEvent[failName][destName] then -- Acquiring Target
				if (timestamp - self.LastEvent[failName][destName]) > 9 then -- 4 + 4 + 1
					lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
				end
			else
				lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			end
			return
		elseif failName == "Fail_Blackwing Descent_Maloriak_Engulfing Darkness" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Omnotron Defense System_Arcane Blowback" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Maloriak_Magma Jets" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Maloriak_Absolute Zero" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Throne of the Four Winds_The Conclave of Wind_Wind Blast" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Cho'gall_Blaze" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Cho'gall_Corrupting Crash" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Throne of the Four Winds_The Conclave of Wind_Permafrost" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Nefarian's End_Shadowblaze" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Sinestra_Twilight Slicer" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Sinestra_Twilight Extinction" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_The Bastion of Twilight_Sinestra_Twilight Pulse" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Nefarian's End_Tail Lash" then
			self:ScheduleTimer("Nefarian's End_Tail Lash", function()
				if self.LastEvent["Lightning Discharge"] then
					if timestamp - self.LastEvent["Lightning Discharge"] > 5 then
						self:FailEvent(failName,destName,self.FAIL_TYPE_MOVING)
						return
					end
				end
			end, 2)
		elseif failName == "Fail_Firelands_Lord Rhyolith_Immolation" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Alysrazor_Fiery Tornado" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Alysrazor_Lava Spew" and damage > 0 then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Shannox_Immolation Trap" and damage > 0 then
			lib:Antispam(true, 10, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Majordomo Staghelm_Searing Seed" then
			if sourceName == destName then return end
			lib:Antispam(true, 3, nil, failName, sourceName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Majordomo Staghelm_Flame Scythe" then
			self.RaidTable[destName] = timestamp
		elseif failName == "Fail_Firelands_Lord Rhyolith_Magma Flow" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Lord Rhyolith_Magma" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Alysrazor_Firestorm" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Alysrazor_Brushfire" and damage > 0 then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Engulfing Flames" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Lava Wave" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Sulfuras Smash" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Dreadflame" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Wrath of Ragnaros" then
			if self.LastEvent[failName][destName] then
				self.LastEvent[failName][destName] = self.LastEvent[failName][destName] + 1
			else
				self.LastEvent[failName][destName] = 1
			end
			if self.LastEvent[failName][destName] > 1 then
				self:FailEvent(failName,destName,self[failType])
				self.LastEvent[failName][destName] = nil
			end
			self:ScheduleTimer("Ragnaros_Wrath of Ragnaros", function()
				lib.LastEvent["Fail_Firelands_Ragnaros_Wrath of Ragnaros"] = {}
			end, 3)
			return
		elseif failName == "Fail_Dragon Soul_Morchok_Stomp" then
			if lib:IsDebuffed(destName) and damage > 0 then
				lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
				return
			end
		elseif failName == "Fail_Dragon Soul_Warmaster Blackhorn_Twilight Flames" then
			lib:Antispam(false, self.CONSTRAINTS[failName]["Time Constraint - Low"] , self.CONSTRAINTS[failName]["Time Constraint - High"] , failName, destName, failType, timestamp)
			return
		end
	end
end

function lib:SWING_DAMAGE(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, damage, overkill)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	damage = damage ~= "ABSORB" and damage or 0
	overkill = overkill or 0

	if lib:IsRaidPet(sourceName) and isPlayerEvent and GetZoneText() == lib:GetLocalizedZone("Fail_Blackwing Descent_Nefarian's End_Stolen Power") then
		lib:Antispam(true, 3, nil, "Fail_Blackwing Descent_Nefarian's End_Stolen Power", UnitName(lib:IsRaidPet(sourceName)), "FAIL_TYPE_NOTATTACKING", timestamp)
	end

--11/6 18:20:23.374  SWING_DAMAGE,0xF130AABB00002A66,"Blood of the Old God",0xa48,0x0100000000509499,"Mackzter",0x514,14238,-1,32,6102,0,0,nil,nil,nil
--Might need to add it to SWING_MISSED too if it turns out that misses make you go even more insane
     if isPlayerEvent then
        local sourceMobID = self:GetMobId(sourceGUID)
	if sourceMobID == 43707 then
		lib:Antispam(true, 3, nil, "Fail_The Bastion of Twilight_Cho'gall_Blood", destName, "FAIL_TYPE_MOVING", timestamp)
		return
	end

	if sourceMobID == 42897 then
		lib:Antispam(true, 3, nil, "Fail_Blackwing Descent_Omnotron Defense System_Poison Bomb", destName, "FAIL_TYPE_MOVING", timestamp)
		return
	end

	if (sourceMobID == 52624 or sourceMobID == 52137 or sourceMobID == 15009) and
	   (overkill > 0 or not lib.OVERKILL_ONLY_LIST["Fail_Zul'Gurub_Jin'do the Godbreaker_Twisted Spirit"]) then
		lib:Antispam(true, 3, nil, "Fail_Zul'Gurub_Jin'do the Godbreaker_Twisted Spirit", destName, "FAIL_TYPE_MOVING", timestamp)
		return
	end
     end

	local destUnitID = lib:findTargetByGUID(destGUID)
	if destUnitID and lib:IsBuffed(destUnitID) then
		if UnitIsUnit("boss1",destUnitID) or UnitIsUnit("boss2",destUnitID) or UnitIsUnit("boss3",destUnitID) or UnitIsUnit("boss4",destUnitID) then
			if lib:IsRaidPet(sourceName) then
				lib:Antispam(true, 5, nil, "Fail_Blackwing Descent_Omnotron Defense System_Barrier", lib:IsRaidPet(sourceName), "FAIL_TYPE_NOTATTACKING", timestamp, sourceName.." - "..(GetSpellInfo(5547))) -- Swing
			else
				lib:Antispam(true, 5, nil, "Fail_Blackwing Descent_Omnotron Defense System_Barrier", sourceName, "FAIL_TYPE_NOTATTACKING", timestamp, (GetSpellInfo(5547))) -- Swing
			end
		end
	end

end

function lib:SWING_MISSED(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	if lib:IsRaidPet(sourceName) and isPlayerEvent and GetZoneText() == lib:GetLocalizedZone("Fail_Blackwing Descent_Nefarian's End_Stolen Power") then
		lib:Antispam(true, 3, nil, "Fail_Blackwing Descent_Nefarian's End_Stolen Power", UnitName(lib:IsRaidPet(sourceName)), "FAIL_TYPE_NOTATTACKING", timestamp)
	end

	if self:GetMobId(sourceGUID) == 43707 and isPlayerEvent then
		lib:Antispam(true, 3, nil, "Fail_The Bastion of Twilight_Cho'gall_Blood", destName, "FAIL_TYPE_MOVING", timestamp)
		return
	end

	if self:GetMobId(sourceGUID) == 42897 and isPlayerEvent and GetRaidDifficulty()%2 == 0 then -- Lets allow using immunity/deterrance/whatever in 10 mans
		lib:Antispam(true, 3, nil, "Fail_Blackwing Descent_Omnotron Defense System_Poison Bomb", destName, "FAIL_TYPE_MOVING", timestamp)
		return
	end

end

function lib:SPELL_INTERRUPT(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, interruptedSpellId, interruptedSpellName, interruptedSpellSchool)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	--12/22 20:53:36.024  SPELL_INTERRUPT,0x05000000032FE2ED,"Stekharn",0x514,0xF150A4B60000104B,"Arcanotron",0x10a48,1766,"Kick",0x1,91542,"Arcane Annihilator",64
	if self:GetMobId(destGUID) == 42166 then
		self.LastEvent["Fail_Blackwing Descent_Omnotron Defense System_Barrier"][sourceName] = timestamp
	end
	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if isPlayerEvent and failName == "Fail_Firelands_Ragnaros_Hand of Ragnaros" then
	   self:FailEvent(failName,destName,self[failType])
	   return
	end
end

function lib:SPELL_CAST_START(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool)
-- ### remember to remove debug events
--[===[@debug@
--[[
	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName then
		if failName == "Fail_Glob -'bal_Ca 'leb_Dismiss Pet" then
			lib:Antispam(true, 1, nil, failName, sourceName, failType, timestamp)
		elseif failName == "Fail_Glob -'bal_Maat_HL" then
			lib:Antispam(true, 1, nil, failName, sourceName, failType, timestamp)
		end
	end
	]]--
--@end-debug@]===]
end

function lib:SPELL_INSTAKILL(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if failName == "Fail_Dragon Soul_Ultraxion_Fading Light" then
			self:FailEvent(failName,destName,self[failType])
		end
	end
end

function lib:SPELL_PERIODIC_DAMAGE(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, damage, overkill)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	damage = damage ~= "ABSORB" and damage or 0
	overkill = overkill or 0

	if isPlayerEvent and lib:GeneralDamageFail(spellId, destName, damage, overkill, timestamp) then return end

        local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if (lib.OVERKILL_ONLY_LIST[failName] or lib.OVERKILL_ONLY_LIST.ovkoverride) and overkill <= 0 then
	  	  return
	  	end
		if failName == "Fail_Throne of the Four Winds_Al'Akir_Squall Line" then
			lib:Antispam(true, 12, nil, failName, destName, failType, timestamp) -- 12 might not be enough
			return
		elseif failName == "Fail_Throne of the Four Winds_The Conclave of Wind_Toxic Spores" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Maloriak_Dark Sludge" and damage > 0 then
			if overkill > 0 then
				self:FailEvent(failName,destName,self[failType])
			else
				if self.LastEvent[failName][destName] then
					self.LastEvent[failName][destName] = self.LastEvent[failName][destName] + damage
				else
					self.LastEvent[failName][destName] = damage
				end
				if self.LastEvent[failName][destName] > self.CONSTRAINTS[failName]["Damage Constraint"] then
					self:FailEvent(failName,destName,self[failType])
					self.LastEvent[failName][destName] = nil
				end
			end
			return
		elseif failName == "Fail_Firelands_Majordomo Staghelm_Leaping Flames" then
			lib:Antispam(false, self.CONSTRAINTS[failName]["Time Constraint - Low"] , self.CONSTRAINTS[failName]["Time Constraint - High"] , failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Firelands_Ragnaros_Lava Wave" then
			lib:Antispam(true, 5, nil, failName, destName, failType, timestamp)
			return
		end
	end

end

function lib:SPELL_AURA_APPLIED(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, auraType)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	if spellName == (GetSpellInfo(92036)) then -- Acquiring Target
		self.LastEvent["Fail_Blackwing Descent_Omnotron Defense System_Flamethrower"][destName] = timestamp
	end

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if failName == "Fail_The Bastion of Twilight_Ascendant Council_Frozen" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Blackwing Descent_Magmaw_Parasitic Infection" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Blackwing Descent_Maloriak_Consuming Flames" then
			self.RaidTable[destName] = false
		elseif failName == "Fail_Firelands_Shannox_Crystal Prison Trap" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Firelands_Baleroc, the Gatekeeper_Tormented" then
			if self:IsDebuffed(destName) then return end
			if self.RaidTable[destName] then
				if (timestamp - self.RaidTable[destName]) > 3 then
					self:FailEvent(failName,destName,self[failType])
				end
			else
				self:FailEvent(failName,destName,self[failType])
			end
		elseif failName == "Fail_Firelands_Alysrazor_Gushing Wound" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Firelands_Alysrazor_Harsh Winds" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Halls of Origination_Isiset, Construct of Magic_Supernova" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Halls of Origination_Earthrager Ptah_Consume" then
			self:FailEvent(failName,destName,self[failType])
		elseif failName == "Fail_Dragon Soul_Spine of Deathwing_Fiery Grip" then
			self.RaidTable[destName] = true
		end
	end

end

function lib:SPELL_AURA_APPLIED_DOSE(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, auraType, stack)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if failName == "Fail_Blackwing Descent_Nefarian's End_Magma" and stack == self.CONSTRAINTS[failName]["Tick Constraint"] then
			if self:IsDebuffed(destName) or not UnitAffectingCombat(destName) then return end
			if GetInstanceDifficulty() > 2 then
				if self.RaidTable[destName] then
					if (timestamp - self.RaidTable[destName]) > 3 then
						self:FailEvent(failName,destName,self[failType])
					end
				else
					self:FailEvent(failName,destName,self[failType])
				end
			else
				self:FailEvent(failName,destName,self[failType])
			end
		elseif failName == "Fail_Firelands_Baleroc, the Gatekeeper_Torment" then
			if stack == self.CONSTRAINTS[failName]["Tick Constraint"] then
				self:FailEvent(failName,destName,self[failType],stack)
			end
			self.RaidTable[destName] = timestamp
		elseif failName == "Fail_Firelands_Majordomo Staghelm_Burning Orb" then
			if stack == self.CONSTRAINTS[failName]["Tick Constraint"] then
				self:FailEvent(failName,destName,self[failType],stack)
			end
		elseif failName == "Fail_Dragon Soul_Yor'sahj the Unsleeping_Deep Corruption" and stacks > 4 then
			self.RaidTable[destName] = true
		end
	end

end

function lib:SPELL_CAST_SUCCESS(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool)

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName then
		if failName == "Fail_Blackwing Descent_Maloriak_Scorching Blast" then
			self:ScheduleTimer("Maloriak_Scorching Blast", function()
				for name, lastTime in pairs(lib.RaidTable) do
					if lib:IsDebuffed(name) then return end
					if type(lastTime) == "number" and not UnitIsDeadOrGhost(name) then
						if (timestamp - lastTime) > 4 then
							self:FailEvent(failName,name,self[failType])
						end
					elseif type(lastTime) == "boolean" and not UnitIsDeadOrGhost(name) then
						self:FailEvent(failName,name,self[failType])
					end
				end
				lib:InitRaidTable()
			end, 1)
			return
		elseif failName == "Fail_Firelands_Majordomo Staghelm_Flame Scythe" then
			self:ScheduleTimer("Majordomo Staghelm_Flame Scythe", function()
				for name, lastTime in pairs(lib.RaidTable) do
					if type(lastTime) == "number" and not UnitIsDeadOrGhost(name) then
						if (timestamp - lastTime) > 4 then
							self:FailEvent(failName,name,self[failType])
						end
					elseif type(lastTime) == "boolean" and not UnitIsDeadOrGhost(name) then
						self:FailEvent(failName,name,self[failType])
					end
				end
				lib:InitRaidTable()
			end, 1)
			return
		elseif failName == "Fail_Dragon Soul_Spine of Deathwing_Fiery Grip" then
			corruptionCasted = true
			lib:InitRaidTable()
			self:ScheduleTimer("Dragon Soul_Spine of Deathwing_Fiery Grip", function()
				for name, excluded in pairs(lib.RaidTable) do
					if not excluded and not UnitIsDeadOrGhost(name) then
						local class = select(2, UnitClass(name))
																																		-- moonkin form, shadowform
						if class == "HUNTER" or class == "WARLOCK" or class == "MAGE" or (class == "DRUID" and UnitBuff(name, GetSpellInfo(24858))) or (class == "PRIEST" and UnitBuff(name, GetSpellInfo(15473))) then
							self:FailEvent(failName,name,self[failType])
						end
					end
				end
				corruptionCasted = false
			end, 3)
			return
		end
	end

end

function lib:SPELL_PERIODIC_HEAL(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overhealing, absorbed, critical)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	if self.RaidTable[destName] and not deepCorruptionSpellIdExceptions[spellId] then
		lib:Antispam(true, 3, nil, "Fail_Dragon Soul_Yor'sahj the Unsleeping_Deep Corruption", sourceName, lib.FAIL_TYPE_NOTCASTING, timestamp, spellName)
		return
	end
end

function lib:SPELL_HEAL(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overhealing, absorbed, critical)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0
	if self.RaidTable[destName] and not deepCorruptionSpellIdExceptions[spellId] then
		lib:Antispam(true, 3, nil, "Fail_Dragon Soul_Yor'sahj the Unsleeping_Deep Corruption", sourceName, lib.FAIL_TYPE_NOTCASTING, timestamp, spellName)
		return
	end
end

function lib:SPELL_ENERGIZE(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, powerType)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName then
		if failName == "Fail_Blackwing Descent_Atramedes_Sonar Pulse" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Atramedes_Sonar Bomb" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		elseif failName == "Fail_Blackwing Descent_Atramedes_Sonic Breath" then
			lib:Antispam(true, 3, nil, failName, destName, failType, timestamp)
			return
		end
	end
end

function lib:SPELL_DISPEL(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, extraSpellId, extraSpellName)

	local failName, failType = lib:SpellIdCheck(extraSpellId, failEvents)
	if failName then
		if failName == "Fail_Zul'Gurub_Zanzil_Toxic Torment" or
		   failName == "Fail_Zul'Gurub_Zanzil_Frostburn Formula" then
			lib:Antispam(true, 3, nil, failName, sourceName, failType, timestamp)
			return
		end
	end
end

function lib:SPELL_AURA_REMOVED(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool)
	local isPlayerEvent = bit.band(destFlags or 0, COMBATLOG_OBJECT_TYPE_PLAYER) > 0

	if spellId == 79339 then
		self.RaidTable[destName] = timestamp
	elseif spellId == 99516 then
		self.RaidTable[destName] = timestamp
	end

	local failName, failType = lib:SpellIdCheck(spellId, failEvents)
	if failName and isPlayerEvent then
		if failName == "Fail_Blackwing Descent_Maloriak_Consuming Flames" then
			self.RaidTable[destName] = timestamp
		elseif failName == "Fail_Firelands_Baleroc, the Gatekeeper_Tormented" then
			self.RaidTable[destName] = false
		elseif failName == "Fail_Dragon Soul_Yor'sahj the Unsleeping_Deep Corruption" then
			self.RaidTable[destName] = false
		end
	end
end

